POJ 3613 Cow Relays (Floyd + 矩阵快速幂 + 离散化 神题!)

Cow Relays

Time Limit: 1000MS   Memory Limit: 65536K
Total Submissions: 5611   Accepted: 2209

Description

For their physical fitness program, N (2 ≤
N ≤ 1,000,000) cows have decided to run a relay race using the T (2 ≤
T ≤ 100) cow trails throughout the pasture.

Each trail connects two different intersections (1 ≤
I1i ≤ 1,000; 1 ≤ I2i ≤ 1,000), each of which is the termination for at least two trails. The cows know the
lengthi of each trail (1 ≤ lengthi  ≤ 1,000), the two intersections the trail connects, and they know that no two intersections are directly connected by two different trails. The trails form a structure known mathematically
as a graph.

To run the relay, the N cows position themselves at various intersections (some intersections might have more than one cow). They must position themselves properly so that they can hand off the baton cow-by-cow and end
up at the proper finishing place.

Write a program to help position the cows. Find the shortest path that connects the starting intersection (S) and the ending intersection (E) and traverses exactly
N cow trails.

Input

* Line 1: Four space-separated integers: N,
T, S, and E

* Lines 2..T+1: Line i+1 describes trail i with three space-separated integers:
lengthi , I1i , and I2i

Output

* Line 1: A single integer that is the shortest distance from intersection
S to intersection E that traverses exactly N cow trails.

Sample Input

2 6 6 4
11 4 6
4 4 8
8 4 9
6 6 8
2 6 9
3 8 9

Sample Output

10

Source

USACO 2007 November Gold

题目链接:http://poj.org/problem?id=3613

题目大意:求从起点s到终点e经过k条边的最短路径

题目分析:01邻接矩阵A的K次方C=A^K,C[i][j]表示i点到j点正好经过K条边的路径数,而Floyd则是每次使用一个中间点k去更新i,j之间的距离,那么更新成功表示i,j之间恰有一个点k时的最短路,做n - 1次Floyd即是在i,j之间经过n - 1 个点时的最短路,i,j之间有n-1个点即有n条边,因为n比较大,考虑采用矩阵快速幂来求,还有就是这题的t比较小,但是l1,l2比较大,所以将其离散化,因为t最大为100,所以离散化后最多有200个点

#include <cstdio>
#include <cstring>
int h[205], cnt;

struct matrix
{
    int m[205][205];
    matrix()
    {
        memset(m, 0x3f, sizeof(m));
    }
};

matrix Floyd(matrix a, matrix b)
{
    matrix ans;
    for(int k = 1; k <= cnt; k++)
        for(int i = 1; i <= cnt; i++)
            for(int j = 1; j <= cnt; j++)
                if(ans.m[i][j] > a.m[i][k] + b.m[k][j])
                    ans.m[i][j] = a.m[i][k] + b.m[k][j];
    return ans;
}

matrix quickmod(matrix a, int k)
{
    matrix ans = a;
    while(k)
    {
        if(k & 1)
            ans = Floyd(ans, a);
        k >>= 1;
        a = Floyd(a, a);
    }
    return ans;
}

int main()
{
    int n, t, s, e;
    cnt = 1;
    matrix ans;
    scanf("%d %d %d %d", &n, &t, &s, &e);
    memset(h, 0, sizeof(h));
    for(int i = 0; i < t; i++)
    {
        int u, v, w;
        scanf("%d %d %d", &w, &u, &v);
        if(!h[u])
            h[u] = cnt++;
        if(!h[v])
            h[v] = cnt++;
        if(ans.m[h[u]][h[v]] > w)
            ans.m[h[u]][h[v]] = ans.m[h[v]][h[u]] = w;
    }
    ans = quickmod(ans, n - 1);
    printf("%d\n", ans.m[h[s]][h[e]]);
}
时间: 2024-10-12 16:38:35

POJ 3613 Cow Relays (Floyd + 矩阵快速幂 + 离散化 神题!)的相关文章

poj 3613 Cow Relays(矩阵的图论意义)

题解 用一个矩阵来表示一个图的边的存在性,即矩阵C[i,j]=1表示有一条从i到j的有向边C[i,j]=0表示没有从i到j的边.这个矩阵的k次方后C[i,j]就表示有多少条从i到j恰好经过k条边的路径. 在此题中我们赋予边权值并把矩阵乘法中的+改为min这样这个矩阵的k次方后C[i,j]就表示从i到j恰好经过k条边的最短路径. 1 #include<iostream> 2 #include<cstring> 3 #include<cstdio> 4 #include&l

POJ 3613 Cow Relays (floyd + 矩阵快速幂)

题目大意: 求刚好经过K条路的最短路 我们知道如果一个矩阵A[i][j] 表示表示 i-j 是否可达 那么 A*A=B  B[i][j]  就表示   i-j 刚好走过两条路的方法数 那么同理 我们把i-j 的路径长度存到A 中. 在A*A的过程中,不断取小的,那么最后得到的也就是i - j 走过两条路的最短路了. 当然也是利用到了floyd的思想. 然后要求出K次的最短路,那么就是矩阵快速幂的工作了. 注意要离散化.用map #include <cstdio> #include <io

矩阵十题【十】 poj 3613 Cow Relays

题目链接:http://poj.org/problem?id=3613 题目大意: 输入N,T,S,E,N表示要走的边数,T表示一共有几条边,S表示开始的点,E表示结束的点 给出一张无向连通图,求S到E经过N条边的最短路. N (2 ≤ N ≤ 1,000,000) T (2 ≤ T ≤ 100) (1 ≤ I1i ≤ 1,000; 1 ≤ I2i ≤ 1,000) 1 ≤ lengthi  ≤ 1,000 题目主要的思想就是用矩阵的乘法模拟出Floyd进行运算,是个很好的题目. //k步最短路

POJ 3613 Cow Relays 恰好n步的最短路径

http://poj.org/problem?id=3613 题目大意: 有T条路,从s到e走n步,求最短路径. 思路: 看了别人的... 先看一下Floyd的核心思想: edge[i][j]=min(edge[i][j],edge[i][k]+edge[k][j]) i到j的最短路是i到j的直接路径或者经过k点的间接路径,但是矩阵的更新总是受到上一次更新的影响 如果每次的更新都存进新矩阵,那么edge[i][k]+edge[k][j]是不是表示只经过三个点两条边的路径呢? min(edge[i

POJ 3233 - Matrix Power Series ( 矩阵快速幂 + 二分)

POJ 3233 - Matrix Power Series ( 矩阵快速幂 + 二分) #include <cstdio> #include <cstring> #include <algorithm> using namespace std; typedef long long LL; #define MAX_SIZE 30 #define CLR( a, b ) memset( a, b, sizeof(a) ) int MOD = 0; int n, k; st

poj 2888 Magic Bracelet(Polya+矩阵快速幂)

Magic Bracelet Time Limit: 2000MS   Memory Limit: 131072K Total Submissions: 4990   Accepted: 1610 Description Ginny’s birthday is coming soon. Harry Potter is preparing a birthday present for his new girlfriend. The present is a magic bracelet which

POJ 3744 Scout YYF I 矩阵快速幂

Scout YYF I Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 4452   Accepted: 1159 Description YYF is a couragous scout. Now he is on a dangerous mission which is to penetrate into the enemy's base. After overcoming a series difficulties,

poj 3150 Cellular Automaton(矩阵快速幂)

http://poj.org/problem?id=3150 大致题意:给出n个数,问经过K次变换每个位置上的数变为多少.第i位置上的数经过一次变换定义为所有满足 min( abs(i-j),n-abs(i-j) )<=d的j位置上的数字之和对m求余. 思路: 我们先将上述定义表示为矩阵 B =  1 1 0 0 1 1 1 1 0 0 0 1 1 1 0 0 0 1 1 1 1 0 0 1 1 B[i][j] = 表示i与j满足上述关系,B[i][j] = 0表示i与j不满足上述关系.根据这个

POJ 3735 Training little cats 矩阵快速幂应用

点击打开链接 Training little cats Time Limit: 2000MS   Memory Limit: 65536K Total Submissions: 9807   Accepted: 2344 Description Facer's pet cat just gave birth to a brood of little cats. Having considered the health of those lovely cats, Facer decides to